#ifndef __prototypes_h__
#define __prototypes_h__

#include <gccore.h>

void NewBlock(int player);

extern int timing[];

class cblock
{
public:

	u8 map[4][4];

	int xtile;
	int ytile;

	int xstart;
	int ystart;

	int xend;
	int yend;

	int rot;
	
	int blocknum;
	
	int lines;
	
	int speedpressed;
	int haspressed;
	
	int waitnum;
	int speed;
	int linesinframe;

	int level;
	u8 gfx;
};

class cblockdesc
{
	public:
	char map[4][4][4];
	
	int xstart[4];
	int ystart[4];

	int xend[4];
	int yend[4];
};

class coptions{
public:
	int players;
	int menuchoice;
	int menuchoiceopt;
	bool inMenu;
	bool mainMenu;
	int tplines;
	int tpspeedprog;
	bool init;
	int pause;
	int netplay;
};

void Reset();

extern int frames;

void DrawBlock(int player);
void DrawSquare(int x,int y,u8 gfx,int player);
void DrawSquareEx(int x,int y,u8 gfx);
void DrawMap(int player);
void rotate(int way,int player);

void SetupBlocks();

int RemoveLines(int player);
void RemoveLine(int line,int player);
int TestRotate(int way,int player);
void DoInput();
void DoMovement(int player);
void KeyRefresh();

extern "C"
{
void sgenrand(unsigned long seed);
double genrand();
}

void BuildBg();
void AddBorder();
void SetupLetters();
void RootMenu();
void OptionsMenu();
void winner(int player);
void FadeOutMusicAndStop();

void game();

void waitVsync();

void FillBlockInfo(cblock& p);
bool canPlace(int player);
bool MoveBlock(int type, int player);

#endif
