#include <gccore.h> 

#include "defines.h"
#include "globals.h"

#include "pieces_bin.h"

void SetupBlocks()
{
	// Fill in data for every block
	for(int i = 0; i < NUMTYPES; i++)
	{
		cblockdesc& desc = blocks[i];

		// Every rotation
		for(int rot = 0; rot < 4; rot++)
		{

			desc.xstart[rot] = 4;
			desc.xend[rot] = -1;

			desc.ystart[rot] = 4;
			desc.yend[rot] = -1;

			// Every square
			for(int y = 0; y < 4; y++)
			{
				for(int x = 0; x < 4; x++)
				{
					// Get square from data file
					desc.map[rot][x][y] = pieces_bin[i * 4 * 4 * 4 + rot * 4 * 4 + y * 4 + x];

					if(desc.map[rot][x][y])
					{
						// Found x start
						if(x < desc.xstart[rot])
							desc.xstart[rot] = x;
					
						// Found x end
						if(x > desc.xend[rot])
							desc.xend[rot] = x;

						// Found y start
						if(y < desc.ystart[rot])
							desc.ystart[rot] = y;

						// Found y end
						if(y > desc.yend[rot])
							desc.yend[rot] = y;
					}
				}
			}
		}
	}
}
