#include <gccore.h> 

#include "defines.h"
#include "globals.h"
#include "text.h"
#include "prototypes.h"

#define EMU

bool MoveBlock(int type, int player)
{
	cblock& p = block[player];
	cblockdesc desc = blocks[p.blocknum];

	int oldx = p.xtile;
	int oldy = p.ytile;

	switch(type)
	{
	case DOWN:
		p.ytile++;
		break;

	case LEFT:
		p.xtile--;
		break;

	case RIGHT:
		p.xtile++;
		break;
	}

	if(canPlace(player))
		return true;
	else
	{
		p.xtile = oldx;
		p.ytile = oldy;
	}

	return false;
}

void DoMovement(int player)
{
	cblock& p = block[player];

	bool move = MoveBlock(DOWN, player);
	bool place = canPlace(player);

	// Write piece to map if it can't be moved more
	if(!move)
	{
		for(int y = 0; y < 4; y++)
		{
			for(int x = 0; x < 4; x++)
			{
				int calcx = p.xtile + x;
				int calcy = p.ytile + y;

				if(calcx >= 0 && calcx < 10 && calcy >= 0 && calcy < 20 && p.map[x][y])
					map[player][calcx][calcy] = p.gfx;
			}
		}
	}

	// Player can't move or place, = dead
	if(!move && !place)
	{
		if(options.players==1)
		{
			while(!(pad[0].button & PAD_BUTTON_START))
			{
				waitVsync();

				DrawMap(0);
				WriteText(95, 200, "you lost", xfb);
			}

			options.mainMenu = true;
			options.inMenu = true;

			game();
		}
		else
		{
			//FadeOutMusicAndStop();
			if(player==0)
				winner(1);
			if(player==1)
				winner(0);
		}
	}

	// Can't move, make a new block
	if(!move)
	{
		while(RemoveLines(player))
		{p.linesinframe++;}

		if(p.linesinframe==4)
		{
			p.lines+=2;
			p.linesinframe=0;
		}
		else if(p.linesinframe==3)
		{
			p.lines+=1;
			p.linesinframe=0;
		}
		else
			p.linesinframe=0;

		NewBlock(player);
	}

#ifndef EMU
		if(options.netplay==1 && player==0)
			GC_BBA_SendUDPE(9003,(unsigned char*)map[0],200);
#endif
}
