/*

This code is 5 years old and crappy. If you're going to learn from it,
it's how *not* to do things. You have been warned.

Christian Auby / DesktopMan 2008
christian{[at]}auby.no
http://www.auby.no

*/

#include <string.h> 

#include <gccore.h> 
#include <gcmodplay.h> 
#include <ogcsys.h> 

#include <gcmodplay.h>

#include "colordefines.h"
#include "math.h"
#include "defines.h"
#include "prototypes.h"
#include "globals.h"
#include "text.h"

#include "tetris_mod.h"

static MODPlay play;

int currFrame = 0;
bool firstFrame = true;

void (*reload)() = (void(*)())0x90000020;
void (*reloadGecko)() = (void(*)())0x80001800;

void waitVsync()
{
	VIDEO_SetNextFramebuffer((void*)xfbFrame[currFrame]);
	
	if(firstFrame)
	{
		firstFrame = 0;
		VIDEO_SetBlack(FALSE);
	}	

	VIDEO_Flush();

	PAD_ScanPads();

	VIDEO_WaitVSync();
	currFrame ^= 1;

	xfb = xfbFrame[currFrame];
	PAD_Read(pad);

	if(pad[0].button & (PAD_TRIGGER_L))
		reload();
	
	if(pad[0].button & (PAD_TRIGGER_R))
		reloadGecko();
}

int main()
{
	VIDEO_Init();
	PAD_Init();
	AUDIO_Init(NULL);

	GXRModeObj *rmode;

	switch(VIDEO_GetCurrentTvMode())
	{
	case VI_NTSC:
		rmode = &TVNtsc480IntDf;
		break;
	case VI_PAL:
		rmode = &TVPal528IntDf;
		break;
	case VI_MPAL:
		rmode = &TVMpal480IntDf;
		break;
	default:
		rmode = &TVNtsc480IntDf;
		break;

	}

	VIDEO_Configure(rmode);

	currFrame = 0;
	firstFrame = 1;

	xfbFrame[0] = (u32*)MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	xfbFrame[1] = (u32*)MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfbFrame[0]);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	currFrame ^= 1;

	xfb = xfbFrame[currFrame];

	MODPlay_Init(&play);
	MODPlay_SetMOD(&play, tetris_mod);
	MODPlay_Start(&play);

	game();
}

void game()
{
	Reset();

	BuildBg();

	SetupBlocks();
	SetupLetters();

	int seed = 0;

	while(pad[0].button & PAD_BUTTON_A)
		PAD_Read(pad);

	// Linger in menus until selection
	while(options.inMenu)
	{
		seed++;

		if(options.mainMenu)
			RootMenu();
		else
			OptionsMenu();
	}

	// Interpret selection
	switch(options.menuchoice)
	{
	case 0:
		options.players=1;
		NewBlock(0);
		break;

	case 1:
		options.players=2;

		NewBlock(0);
		NewBlock(1);
		break;

	case 3:
		reload();

	case 4:
		reloadGecko();

	default:
		reload();
	}

	// Write the candy border
	AddBorder();

	sgenrand(seed);

	if(options.players == 1)
	{
		for(int y = 0; y < 400;y++)
		{
			for(int x = 0;x < 100;x++)
				bg[(y + 40) * 320 + x + 110] = COLOR_BLACK;
		}
	}
	else
	{
		for(int y = 0; y < 400;y++)
		{
			for(int x=0;x < 100;x++)
				bg[(y + 40) * 320 + x + 30] = COLOR_BLACK;
		}

		for(int y = 0; y < 400;y++)
		{
			for(int x = 0; x < 100; x++)
				bg[(y + 40) * 320 + x + 190] = COLOR_BLACK;
		}

	}

	void vblank();

	while(1)
	{
		vblank();
	}
}

void vblank()
{
	waitVsync();

	KeyRefresh();

	frames++;

	memcpy(xfb, bg, 640 * 480 * 2);

	if(options.players==1 && options.netplay == 0)
	{
		WriteText(222, 50, "lines:", xfb);
		WriteNum(222, 82, block[0].lines, xfb, TEXT_HORIZONTAL);
	}
	else{
		WriteNum(140, 20, block[0].lines, xfb, TEXT_VERTICAL);
		WriteNum(164, 20, block[1].lines, xfb, TEXT_VERTICAL);
	}

	for(int player = 0; player < options.players; player++)
	{

		if(frames % block[player].speed == 0 || PAD_StickY(player) < -65 || pad[player].button & PAD_BUTTON_X || pad[player].button & PAD_BUTTON_Y)
			DoMovement(player);

		if((PAD_ButtonsDown(player) & PAD_BUTTON_DOWN))
		{
			while(MoveBlock(DOWN, player));

			frames -= (frames % block[player].speed);
		}

		DrawBlock(player);
	}
	if(options.players == 1)
		DrawMap(0);
	else{
		DrawMap(0);
		DrawMap(1);
	}
}
