#include <string.h> 
#include <stdlib.h>

#include <gccore.h> 

#include "globals.h"
#include "text.h"
#include "prototypes.h"

void RootMenu()
{
	waitVsync();

	memcpy(xfb, bg, 640 * 480 * 2);

	int xoffset, yoffset;

	xoffset = 40;
	yoffset = 50;

	WriteText(20,  yoffset,  "welcome to tetris",  xfb);
	WriteText(xoffset,  yoffset + 25 * 3,  "single player",  xfb);
	WriteText(xoffset,  yoffset + 25 * 4,  "two player",  xfb);

	WriteText(xoffset, yoffset + 25 * 6, "options",  xfb);
	WriteText(xoffset, yoffset + 25 * 8, "reload sd",  xfb);
	WriteText(xoffset, yoffset + 25 * 9, "reload gecko",  xfb);

	WriteText(20,  380,  "christian@auby.no",  xfb);

	switch(options.menuchoice)
	{
	case 0:
		WriteText(xoffset-16, yoffset  +  3 * 25, "*", xfb);
		break;
	case 1:
		WriteText(xoffset-16, yoffset + 4 * 25, "*", xfb);
		break;
	case 2:
		WriteText(xoffset-16, yoffset + 6 * 25, "*", xfb);
		break;
	case 3:
		WriteText(xoffset-16, yoffset + 8 * 25, "*", xfb);
		break;
	case 4:
		WriteText(xoffset-16, yoffset + 9 * 25, "*", xfb);
		break;

	}

	if(((pad[0].button & PAD_BUTTON_DOWN) || PAD_StickY(0) < -65) && block[0].speedpressed==0 && options.menuchoice < 4)
	{
		block[0].speedpressed = 1;
		options.menuchoice++;
	}

	if(((PAD_ButtonsDown(0) & PAD_BUTTON_UP) || PAD_StickY(0) > 65) && block[0].speedpressed==0 && options.menuchoice > 0)
	{
		block[0].speedpressed = 1;
		options.menuchoice--;
	}
	if(!(pad[0].button & PAD_BUTTON_UP) && !(pad[0].button & PAD_BUTTON_DOWN) && PAD_StickY(0) < 65 && PAD_StickY(0) > -65)
		block[0].speedpressed = 0;

	if(PAD_ButtonsDown(0) & PAD_BUTTON_A)
	{
		if(options.menuchoice == 2)
			options.mainMenu = false;
		else
			options.inMenu = false;
	}
}

void OptionsMenu()
{
	waitVsync();

	memcpy(xfb, bg, 640*480*2);

	int xoffset,yoffset;

	xoffset = 40;
	yoffset = 50;

	int nums = 1;

	WriteText(100, yoffset, "options",  xfb);

	WriteText(xoffset, yoffset + 25 * 3, "play", xfb);
	nums = WriteNum(xoffset + 5 * 16, yoffset + 25 * 3, options.tplines, xfb, TEXT_HORIZONTAL);
	WriteText(xoffset + (6 + nums) * 16, yoffset + 25 * 3, "lines", xfb);

	WriteText(xoffset, yoffset + 25 * 4, "speed up:", xfb);
	WriteNum(xoffset + 10 * 16, yoffset + 25 * 4, options.tpspeedprog, xfb, TEXT_HORIZONTAL);

	WriteText(xoffset, yoffset + 25 * 6, "back", xfb);

	WriteText(xoffset, yoffset + 25 * 8, "(only two player)", xfb);
	WriteText(xoffset, yoffset + 25 * 11, "x = defaults", xfb);

	switch(options.menuchoiceopt)
	{
	case 0:
		WriteText(xoffset - 16, yoffset + 25 * 3, "*", xfb);
		break;
	case 1:
		WriteText(xoffset - 16, yoffset + 25 * 4, "*", xfb);
		break;
	case 2:
		WriteText(xoffset - 16, yoffset + 25 * 6, "*", xfb);
		break;
	}

	if(((PAD_ButtonsDown(0) & PAD_BUTTON_DOWN) || PAD_StickY(0) < -65) && block[0].speedpressed==0 && options.menuchoiceopt < 2)
	{
		block[0].speedpressed = 1;
		options.menuchoiceopt++;
	}

	if(((PAD_ButtonsDown(0) & PAD_BUTTON_UP) || PAD_StickY(0) > 65) && block[0].speedpressed==0 && options.menuchoiceopt > 0)
	{
		block[0].speedpressed = 1;
		options.menuchoiceopt--;
	}

	if(options.menuchoiceopt == 0)
	{
		if((PAD_ButtonsDown(0) & PAD_BUTTON_X) || (PAD_ButtonsDown(0) & PAD_BUTTON_Y))
			options.tplines = 30;

		if(PAD_ButtonsDown(0) & PAD_BUTTON_LEFT)
			options.tplines--;

		if(PAD_ButtonsDown(0) & PAD_BUTTON_RIGHT)
			options.tplines++;

		if(PAD_StickX(0) > 65)
			options.tplines += 1;

		if(PAD_StickX(0) < -65)
			options.tplines -= 1;

		if(options.tplines < 0)
			options.tplines = 0;

	}

	if(options.menuchoiceopt==1)
	{
		if((PAD_ButtonsDown(0) & PAD_BUTTON_X) || (PAD_ButtonsDown(0) & PAD_BUTTON_Y))
			options.tpspeedprog = 3;

		if(PAD_ButtonsDown(0) & PAD_BUTTON_LEFT)
			options.tpspeedprog--;

		if(PAD_ButtonsDown(0) & PAD_BUTTON_RIGHT)
			options.tpspeedprog++;
	
		if(PAD_StickX(0) > 65)
			options.tpspeedprog++;

		if(PAD_StickX(0) < -65)
			options.tpspeedprog--;

		if(options.tpspeedprog < 0)
			options.tpspeedprog = 0;
	}

	if(PAD_StickY(0) > -65 && PAD_StickY(0) < 65)
		block[0].speedpressed = 0;

	if((PAD_ButtonsDown(0) & PAD_BUTTON_A && options.menuchoiceopt==2) || (PAD_ButtonsDown(0) & PAD_BUTTON_B))
		options.mainMenu = true;
}
