#include "prototypes.h"
#include "defines.h"
#include "globals.h"

bool canPlace(int player)
{
	cblock& p = block[player];
	cblockdesc& desc = blocks[p.blocknum];

	for(int y = 0; y < 4; y++)
	{
		for(int x = 0; x < 4; x++)
		{
			// Only check squares that are set in the map
			if(desc.map[p.rot][x][y])
			{
				int calcx = p.xtile + x;
				int calcy = p.ytile + y;
				
				// Outside the map?
				if(calcx < 0 || calcx >= 10 || calcy >= 20)
					return false;

				// On top of something else?
				if(calcy >= 0 && map[player][calcx][calcy] != 9)
					return false;
			}
		}
	}

	return true;
}

void rotate(int rot, int player)
{
	cblock& p = block[player];

	int oldRot = p.rot;

	while(rot < 0)
		rot += 4;

	while(rot > 3)
		rot -= 4;

	p.rot = rot;

	FillBlockInfo(p);

	// If the new rotation can't be placed, revert to the old one.
	if(!canPlace(player))
	{
		p.rot = oldRot;
		FillBlockInfo(p);
	}
}
