#include <string.h>

#include <gccore.h>

#include "text.h"
#include "colordefines.h"

#include "font_raw_bin.h"

u32* font_gfx = (u32*)font_raw_bin;

sletter letter[0x80];

char *_itoa(int n, char *buf, int radix)
{
	char   *ret = buf;
	char   tmp[33];
	int   i = 0, j, r;
	/* validate the conversion number base. */
	if ((radix >= 2) && (radix <= 36)) {
		if ((radix == 10) && (n < 0)) {
			/* negative integer value. */
			*buf++ = '-';
			n = -n;
		}
		do {
			/* calculate the current digit. */
			r = (int)((unsigned int)n % radix);
			tmp[i++] = ((r < 10) ? (r + '0') : (r - 10 + 'a'));
		} while (((unsigned int&)n /= radix) != 0);
		/* reverse the buffer string. */
		for (--i, j = 0; (i >= 0); --i, ++j) buf[j] = tmp[i];
		buf[j] = 0;
	}
	return (ret);
}

void WriteText(int x,int y, const char *text,unsigned int *fb,int flags)
{

	if(x == TEXT_RIGHT)
		x = (flags&TEXT_VERTICAL) ? 640-16: 640-(strlen(text)*16);
	else if(x == TEXT_CENTER)
		x = 160-((strlen(text)*16) >> 1);
	else if(x == TEXT_LEFT)
		x = 0;

	if(y == TEXT_TOP)
		y=0;
	else if(y == TEXT_CENTER)
		y=(480 >> 1)-(25 >> 1);
	else if(y == TEXT_BOTTOM)
		y=(flags&TEXT_VERTICAL) ? 480-(strlen(text)*25) : 480-25;

	int startx,starty;
	int pos = 0;

	if(flags & TEXT_VERTICAL)
	{
		while(text[pos] != 0x0)
		{

			startx = letter[(u32)text[pos]].x / 2;
			starty = letter[(u32)text[pos]].y;

			unsigned int color;

			for(int newy = 0; newy < 25; newy++)
			{
				for(int newx = 0; newx < 16; newx++)
				{
					color = font_gfx[(newx+startx)+(newy+starty)*160];
					
					if(color != COLOR_BLACK)
						fb[x + newx + (y + newy + pos * 25) * 320]=color;
				}
			}
			pos++;
		}
	}
	else
	{
		while(text[pos]!=0x0)
		{

			startx=letter[(u32)text[pos]].x/2;
			starty=letter[(u32)text[pos]].y;

			unsigned int color;

			for(int newy=0;newy < 25;newy++)
			{
				for(int newx=0;newx < 16;newx++)
				{
					color=font_gfx[(newx+startx)+(newy+starty)*160];
					if(color!=COLOR_BLACK)
						fb[(x+newx+pos*16)+(y+newy)*320]=color;
				}
			}
			pos++;
		}
	}
}


int WriteNum(int x,int y,int num,unsigned int *fb,int flags)
{
	char buffer[20];

	if(flags&HEX)
		_itoa(num,buffer,16);
	else if(flags&BASE8)
		_itoa(num,buffer,8);
	else if(flags&BASE2)
		_itoa(num,buffer,2);
	else
		_itoa(num,buffer,10);

	WriteText(x,y,buffer,fb,flags);

	return strlen(buffer);
}

void SetupLetters()
{
	letter[' '].x=0;
	letter[' '].y=0;

	letter['a'].x=96;
	letter['a'].y=75;

	letter['b'].x=128;
	letter['b'].y=75;

	letter['c'].x=160;
	letter['c'].y=75;

	letter['d'].x=192;
	letter['d'].y=75;

	letter['e'].x=224;
	letter['e'].y=75;

	letter['f'].x=256;
	letter['f'].y=75;

	letter['g'].x=288;
	letter['g'].y=75;

	letter['h'].x=0;
	letter['h'].y=100;

	letter['i'].x=32;
	letter['i'].y=100;

	letter['j'].x=64;
	letter['j'].y=100;

	letter['k'].x=96;
	letter['k'].y=100;

	letter['l'].x=128;
	letter['l'].y=100;

	letter['m'].x=160;
	letter['m'].y=100;

	letter['n'].x=192;
	letter['n'].y=100;

	letter['o'].x=224;
	letter['o'].y=100;

	letter['p'].x=256;
	letter['p'].y=100;

	letter['q'].x=288;
	letter['q'].y=100;

	letter['r'].x=0;
	letter['r'].y=125;

	letter['s'].x=32;
	letter['s'].y=125;

	letter['t'].x=64;
	letter['t'].y=125;

	letter['u'].x=96;
	letter['u'].y=125;

	letter['v'].x=128;
	letter['v'].y=125;

	letter['w'].x=160;
	letter['w'].y=125;

	letter['x'].x=192;
	letter['x'].y=125;

	letter['y'].x=224;
	letter['y'].y=125;

	letter['z'].x=256;
	letter['z'].y=125;

	letter['!'].x=32;
	letter['!'].y=0;

	letter['"'].x=64;
	letter['"'].y=0;

	letter['#'].x=96;
	letter['#'].y=0;

	letter['$'].x=128;
	letter['$'].y=0;

	letter['%'].x=160;
	letter['%'].y=0;

	letter['&'].x=192;
	letter['&'].y=0;

	letter['\''].x=224;
	letter['\''].y=0;

	letter['('].x=256;
	letter['('].y=0;

	letter[')'].x=288;
	letter[')'].y=0;

	letter['*'].x=0;
	letter['*'].y=25;

	letter['+'].x=32;
	letter['+'].y=25;

	letter[','].x=64;
	letter[','].y=25;

	letter['-'].x=96;
	letter['-'].y=25;

	letter['.'].x=128;
	letter['.'].y=25;

	letter['/'].x=160;
	letter['/'].y=25;

	letter['0'].x=192;
	letter['0'].y=25;

	letter['1'].x=224;
	letter['1'].y=25;

	letter['2'].x=256;
	letter['2'].y=25;

	letter['3'].x=288;
	letter['3'].y=25;

	letter['4'].x=0;
	letter['4'].y=50;

	letter['5'].x=32;
	letter['5'].y=50;

	letter['6'].x=64;
	letter['6'].y=50;

	letter['7'].x=96;
	letter['7'].y=50;

	letter['8'].x=128;
	letter['8'].y=50;

	letter['9'].x=160;
	letter['9'].y=50;

	letter[':'].x=192;
	letter[':'].y=50;

	letter[';'].x=224;
	letter[';'].y=50;

	letter['<'].x=256;
	letter['<'].y=50;

	letter['='].x=288;
	letter['='].y=50;

	letter['>'].x=0;
	letter['>'].y=75;

	letter['?'].x=32;
	letter['?'].y=75;

	letter['@'].x=64;
	letter['@'].y=75;
}
